// Generated by CoffeeScript 1.7.1
var async, block_init, dust, dustHelpers, e, exports, _, _blocks;

_ = require('underscore');

async = require('async');

_blocks = {};


/*
output:
    res.locals.$block = {
        render: (regionName, next) ->
        exists: (regionName) -> boolean
    }
 */

block_init = function(req, res, next) {
  var filter_blocks, regions_blocks;
  res.locals.$block = {};
  regions_blocks = {};
  filter_blocks = (function(_this) {
    return function(region, next) {
      var region_blocks;
      if (regions_blocks[region] != null) {
        return next(null, regions_blocks[region]);
      }
      region_blocks = [];
      return async.each(_blocks, function(block, cb) {
        var block_show, filters;
        filters = block.filters || [];
        block_show = true;
        return async.each(filters, (function(filter, next) {
          if (block_show === false) {
            return next(null);
          }
          return filter({
            region: region,
            req: req,
            res: res
          }, function(err, filter_show) {
            if (err != null) {
              return next(err);
            }
            if (filter_show === false) {
              block_show = false;
            }
            return next(null);
          });
        }), function(err) {
          if ((err == null) && block_show) {
            region_blocks.push(block);
          }
          return cb(err);
        });
      }, function(err) {
        return next(err, region_blocks);
      });
    };
  })(this);
  res.locals.$block.render = (function(_this) {
    return function(region, next) {
      return filter_blocks(region, function(err, blocks) {
        var html;
        html = '';
        return async.each(blocks, (function(_this) {
          return function(block, cb) {
            res.locals.$block.current = block.options || {};
            return block.init(req, res, function(err, result) {
              html = html + (err || result);
              return cb();
            });
          };
        })(this), (function(_this) {
          return function(err) {
            if (err != null) {
              return next(err);
            }
            return next(null, html);
          };
        })(this));
      });
    };
  })(this);
  res.locals.$block.exists = (function(_this) {
    return function(region, next) {
      return filter_blocks(region, function(err, blocks) {
        if (err != null) {
          return next(err);
        }
        return next(null, blocks.length > 0);
      });
    };
  })(this);
  return next();
};


/*
    constructor
    config: {
        blocks: ['blocks']
    }
 */

exports = module.exports = {
  configure: function(config, app) {
    _blocks = config.blocks;
    if (app != null) {
      return app.use(block_init);
    }
  },
  init: block_init,
  filters: {
    region: function(name) {
      return function(options, next) {
        return next(null, options.region.toLowerCase() === name.toLowerCase());
      };
    }
  }
};

try {
  dust = require("dustjs-linkedin");
  dustHelpers = require("dustjs-helpers");
  dustHelpers.helpers['block.render'] = function(chunk, ctx, bodies, params) {
    var block, region;
    if (params == null) {
      params = {};
    }
    block = ctx.get("$block");
    if (block == null) {
      return chunk;
    }
    region = dustHelpers.helpers.tap(params.region, chunk, ctx);
    return chunk.map(function(chunk) {
      return block.render(region, function(err, html) {
        return (chunk.write(err || html)).end();
      });
    });
  };
  dustHelpers.helpers['block.exists'] = function(chunk, ctx, bodies, params) {
    var block, region;
    if (params == null) {
      params = {};
    }
    block = ctx.get("$block");
    if (block == null) {
      return chunk;
    }
    region = dustHelpers.helpers.tap(params.region, chunk, ctx);
    return chunk.map(function(chunk) {
      return block.exists(region, function(err, exists) {
        if (err != null) {
          return chunk.write(err).end();
        }
        if (exists) {
          return chunk.section({}, ctx, bodies).end();
        }
        return chunk.end();
      });
    });
  };
} catch (_error) {
  e = _error;
}

//# sourceMappingURL=block.map
