// Generated by CoffeeScript 1.7.1
var async, cache, coly, dust, exports, extname, fs, join, read, readCache, readPartials, render, _;

_ = require('underscore');

fs = require('fs');

async = require('async');

coly = require('../index');

join = (require('path')).join;

extname = (require('path')).extname;

readCache = {};

readPartials = function(path, options, fn) {
  var keys, next, partials;
  if (!options.partials) {
    return fn();
  }
  partials = options.partials;
  keys = Object.keys(partials);
  next = function(index) {
    var file, key;
    if (index === keys.length) {
      return fn(null);
    }
    key = keys[index];
    file = join(path, partials[key] + extname(path));
    return fs.exists(file, function(exists) {
      if (exists === true) {
        options.partials[key] = file;
      }
      return next(++index);
    });
  };
  return next(0);
};

cache = function(options, compiled) {
  if (compiled && options.filename && options.cache) {
    delete readCache[options.filename];
    cacheStore[options.filename] = compiled;
    return compiled;
  }
  if (options.filename && options.cache) {
    return cacheStore[options.filename];
  }
  return compiled;
};

read = function(path, options, fn) {
  var cached, str;
  str = readCache[path];
  cached = options.cache && str && 'string' === typeof str;
  if (cached) {
    return fn(null, str);
  }
  return fs.readFile(path, 'utf8', function(err, str) {
    if (err) {
      return fn(err);
    }
    str = str.replace(/^\uFEFF/, '');
    if (options.cache) {
      readCache[path] = str;
    }
    return fn(null, str);
  });
};

dust = null;

render = function(str, options, fn) {
  var engine, err, ext, tmpl, views;
  engine = dust;
  if (engine == null) {
    try {
      engine = dust = require('dust');
    } catch (_error) {
      err = _error;
      try {
        engine = dust = require('dustjs-helpers');
      } catch (_error) {
        err = _error;
        engine = dust = require('dustjs-linkedin');
      }
    }
  }
  ext = 'dust';
  views = '.';
  if (options) {
    if (options.ext) {
      ext = options.ext;
    }
    if (options.views) {
      views = options.views;
    }
    if (options.settings && options.settings.views) {
      views = options.settings.views;
    }
  }
  if (!options || (options && !options.cache)) {
    engine.cache = {};
  }
  engine.onLoad = function(path, callback) {
    if ((options.partials != null) && options.partials[path]) {
      path = options.partials[path];
    } else {
      if ('' === extname(path)) {
        path += '.' + ext;
      }
    }
    return read(path, options, callback);
  };
  try {
    tmpl = cache(options) || cache(options, engine.compileFn(str));
    return tmpl(options, fn);
  } catch (_error) {
    err = _error;
    return fn(err);
  }
};

exports = module.exports = function(path, options, fn) {
  options.filename = path;
  return async.eachSeries(coly.view.viewPaths(), (function(x, cb) {
    return readPartials(x, options, cb);
  }), function(err) {
    if (err) {
      return fn(err);
    }
    if (cache(options)) {
      return render('', options, fn);
    } else {
      return read(path, options, function(err, str) {
        if (err) {
          return fn(err);
        }
        return render(str, options, fn);
      });
    }
  });
};

//# sourceMappingURL=dust.map
