// Generated by CoffeeScript 1.7.1
var Form, async, coly, dust, dustHelpers, e, exports, _;

async = require('async');

_ = require('underscore');

coly = require("../index");

Form = (function() {
  function Form(config) {
    this.fields = config.fields, this.url = config.url;
    this.fields = this.fields || {};
  }

  Form.prototype.field = function(name, field) {
    if (field == null) {
      return this.fields[name];
    }
    return this.fields[name] = field;
  };

  Form.prototype.init = function(req, res, next) {
    var field_array;
    res.locals.$form = res.locals.$form || {};
    res.locals.$form.field = (function(_this) {
      return function(name, field) {
        return _this.field(name, field);
      };
    })(this);
    res.locals.$form.url = this.url;
    res.locals.$form.fields = {};
    field_array = _.pairs(this.fields);
    async.each(field_array, (function(x, cb) {
      return x[1].make({
        req: req,
        res: res,
        fieldName: x[0]
      }, function(err, element) {
        if (err != null) {
          return cb(err);
        }
        return res.locals.$form.fields[x[0]] = element;
      });
    }), function(err) {
      if ((_.size(res.locals.$form.errors)) > 0) {
        return next(res.locals.$form.errors, data);
      }
      return next(err);
    });
    return next();
  };

  Form.prototype.val = function(req, res, next) {
    var data, field_array;
    res.locals.$form = res.locals.$form || {};
    res.locals.$form.errors = res.locals.$form.errors || {};
    field_array = _.pairs(this.fields);
    data = {};
    return async.each(field_array, (function(x, cb) {
      return x[1].val({
        req: req,
        res: res,
        fieldName: x[0]
      }, function(err, val) {
        if (err != null) {
          res.locals.$form.errors = res.locals.$form.errors || {};
          res.locals.$form.errors[x[0]] = err;
        }
        data[x[0]] = val;
        return cb(null);
      });
    }), function(err) {
      if ((_.size(res.locals.$form.errors)) > 0) {
        return next(res.locals.$form.errors, data);
      }
      return next(err, data);
    });
  };

  return Form;

})();

exports = module.exports = function(config) {
  return new Form(config);
};

try {
  dust = require("dustjs-linkedin");
  dustHelpers = require("dustjs-helpers");
  dustHelpers.helpers['c.field'] = function(chunk, ctx, bodies, params) {
    var field, form, name;
    if (params == null) {
      params = {};
    }
    form = ctx.get("$form");
    if (!form) {
      return chunk;
    }
    name = dustHelpers.helpers.tap(params.name, chunk, ctx);
    field = form.fields[name];
    if (field == null) {
      return chunk;
    }
    return chunk.write(coly.utils.toHtml(field));
  };
  dustHelpers.helpers['c.error'] = function(chunk, ctx, bodies, params) {
    var $form, error, name;
    if (params == null) {
      params = {};
    }
    $form = ctx.get("$form");
    if (($form == null) || ($form.errors == null)) {
      return chunk;
    }
    name = dustHelpers.helpers.tap(params.name, chunk, ctx);
    error = $form.errors[name];
    if (!error) {
      return chunk;
    }
    return chunk.write("<span class='error-block'>" + error + "</span>");
  };
  dustHelpers.helpers['c.errorClass'] = function(chunk, ctx, bodies, params) {
    var $form, error, name;
    if (params == null) {
      params = {};
    }
    $form = ctx.get("$form");
    if (($form == null) || ($form.errors == null)) {
      return chunk;
    }
    name = dustHelpers.helpers.tap(params.name, chunk, ctx);
    error = $form.errors[name];
    if (!error) {
      return chunk;
    }
    return chunk.write("has-error");
  };
} catch (_error) {
  e = _error;
}

//# sourceMappingURL=form.map
