// Generated by CoffeeScript 1.7.1
var async, dust, dustHelpers, e, exports, i18n_add_folder, i18n_configure, i18n_guessLanguage, i18n_init, path, requireAll, sprintf, vsprintf, _, _defaultLanguage, _detects, _languages;

async = require('async');

requireAll = require('require-all');

path = require('path');

_ = require('underscore');

sprintf = require('sprintf').sprintf;

vsprintf = require('sprintf').vsprintf;

_defaultLanguage = '';

_languages = {};

_detects = {};

i18n_configure = function(config, app) {
  var folder, folders, language, _i, _j, _len, _len1, _ref;
  if (config == null) {
    config = {};
  }
  _defaultLanguage = config.defaultLanguage;
  _detects = config.detects;
  folders = config.folders;
  folders = folders || [];
  _languages = {};
  _ref = config.languages || [];
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    language = _ref[_i];
    _languages[language] = {};
  }
  _detects = _detects || [];
  if (!Array.isArray(_detects)) {
    _detects = [_detects];
  }
  for (_j = 0, _len1 = folders.length; _j < _len1; _j++) {
    folder = folders[_j];
    i18n_add_folder(folder);
  }
  if (app != null) {
    return app.use(i18n_init);
  }
};

i18n_add_folder = function(folder) {
  var files, k, lang, locales, v, _results;
  files = requireAll({
    dirname: folder,
    filter: /(.+)\.json$/,
    excludeDirs: /^\.(git|svn)$/,
    optional: true
  });
  _results = [];
  for (lang in files) {
    locales = files[lang];
    lang = lang.toLowerCase();
    if (_languages[lang] != null) {
      _results.push((function() {
        var _results1;
        _results1 = [];
        for (k in locales) {
          v = locales[k];
          _results1.push(_languages[lang][k] = v);
        }
        return _results1;
      })());
    } else {
      _results.push(void 0);
    }
  }
  return _results;
};

i18n_init = (function(_this) {
  return function(req, res, next) {
    res.locals.$i18n = {
      t: function(key) {
        return key;
      }
    };
    return exports.guessLanguage(req, res, function(err, language) {
      var languages;
      if (err != null) {
        return next(err);
      }
      if (language == null) {
        return next();
      }
      res.locals.$i18n.lang = language;
      languages = _languages[language] || _languages[_defaultLanguage];
      if (languages != null) {
        res.locals.$i18n.t = function(key, context) {
          var text;
          if (context == null) {
            context = {};
          }
          text = languages[key] || key;
          return sprintf(text, context);
        };
      }
      return next();
    });

    /*
        guest the language from request
        in I18n: get first language from accept-languages
     */
  };
})(this);

i18n_guessLanguage = (function(_this) {
  return function(req, res, next) {
    var result;
    result = null;
    return async.each(_detects, function(detect, cb) {
      if (result != null) {
        return cb();
      }
      return detect(req, function(err, language) {
        if (err != null) {
          return cb(err);
        }
        result = language;
        return cb(null, language);
      });
    }, function(err) {
      return next(err, result || _defaultLanguage);
    });
  };
})(this);


/*
    config: {
        languages: []
        detects: []
        folders: ['']
        defaultLanguage: 'zh-cn'
    }
    output:
        res.locals.$i18n = {
            t: 'translate text'
        }
 */

exports = module.exports = {
  configure: i18n_configure,
  init: i18n_init,
  guessLanguage: i18n_guessLanguage,
  addFolder: i18n_add_folder,
  detects: {
    accept: function() {
      return function(req, next) {
        var language, languages, _i, _len;
        languages = req.acceptedLanguages || [];
        for (_i = 0, _len = languages.length; _i < _len; _i++) {
          language = languages[_i];
          if ((language || '').toLowerCase() === language) {
            return next(null, language);
          }
        }
        return next();
      };
    },
    cookie: function(cookieName) {
      return function(req, next) {
        if (req.cookies == null) {
          return next(null, null);
        }
        if (req.cookies[cookieName] != null) {
          return next(null, req.cookies[cookieName]);
        }
        return next(null, null);
      };
    },
    params: function(paramName) {
      return function(req, next) {
        if (req.params == null) {
          return next(null, null);
        }
        if (req.params[paramName] != null) {
          return next(null, req.params[paramName]);
        }
        return next(null, null);
      };
    }
  }
};

try {
  dust = require("dustjs-linkedin");
  dustHelpers = require("dustjs-helpers");
  dustHelpers.helpers['t'] = function(chunk, ctx, bodies, params) {
    var i18n, k, locals, text, v;
    if (params == null) {
      params = {};
    }
    i18n = ctx.get("$i18n");
    locals = {};
    for (k in params) {
      v = params[k];
      if (k !== 'text') {
        locals[k] = dustHelpers.helpers.tap(params[k], chunk, ctx);
      }
    }
    if (i18n == null) {
      return chunk;
    }
    text = dustHelpers.helpers.tap(params.text, chunk, ctx);
    return chunk.write(i18n.t(text, locals));
  };
} catch (_error) {
  e = _error;
}

//# sourceMappingURL=i18n.map
