// Generated by CoffeeScript 1.7.1
var async, exports, mail_accounts, mail_clients, mail_configure, path, _;

path = require('path');

_ = require('underscore');

async = require('async');

mail_clients = {

  /*
      config:
          template: root of the mail templates
          user: the user name of smtp
          password: the password of smtp
          host: the host of the smtp
   */
  smtp: function(config) {
    var nodemailer, transport;
    nodemailer = require("nodemailer");
    transport = nodemailer.createTransport("SMTP", {
      host: config.host,
      auth: {
        user: config.user,
        pass: config.password
      }
    });

    /*
        options:
            to: receiver address
            subject: subject
            text: the text of mail
     */
    return function(options, next) {
      var smtp_option;
      smtp_option = _.extend({}, {
        from: config.from,
        to: options.to,
        subject: options.subject
      });
      smtp_option.html = options.text;
      smtp_option.text = options.text;
      return transport.sendMail(smtp_option, next);
    };
  }
};

mail_accounts = {};

mail_configure = function(config, app) {
  var k, v, _ref, _results;
  _ref = config.accounts;
  _results = [];
  for (k in _ref) {
    v = _ref[k];
    exports.accounts[k.toLowerCase()] = exports.clients[v.client](v);
    _results.push(exports.accounts[k.toLowerCase()].client = v.client);
  }
  return _results;
};

exports = module.exports = {
  configure: mail_configure,
  clients: mail_clients,
  accounts: mail_accounts
};

//# sourceMappingURL=mail.map
