// Generated by CoffeeScript 1.7.1
var async, coly, exports, menu_init, _;

async = require('async');

_ = require('underscore');

coly = require("../index");

menu_init = function(req, res, next) {
  var buildMenu, buildNode, k, menus, node, _fn, _ref;
  menus = {};
  buildNode = function(srcNode, next) {
    var dstNode, filter;
    dstNode = _.extend({}, srcNode);
    filter = dstNode.filter || function(req, res, next) {
      return next(null, true);
    };
    return filter(req, res, function(err, result) {
      var makeNodes;
      if (err != null) {
        return next(err);
      }
      if (result) {
        makeNodes = dstNode.nodes;
        if (Array.isArray(makeNodes)) {
          makeNodes = function(req, res, next) {
            return next(null, dstNode.nodes);
          };
        } else if (!makeNodes) {
          makeNodes = function(req, res, next) {
            return next(null, []);
          };
        }
        return makeNodes(req, res, function(err, nodes) {
          var iterator;
          if (err) {
            return next(err);
          }
          dstNode.nodes = [];
          iterator = function(x, cb) {
            return buildNode(x, function(err, node) {
              if (err != null) {
                return cb(err);
              }
              if (node != null) {
                dstNode.nodes.push(node);
                node.parent = function() {
                  return dstNode;
                };
              }
              return cb(null);
            });
          };
          return async.eachSeries(nodes, iterator, function(err) {
            return next(err, dstNode);
          });
        });
      } else {
        return next(null, null);
      }
    });
  };
  buildMenu = function(name, next) {
    if (menus[name] != null) {
      return next(null, menus[name]);
    }
    return buildNode(exports.menus[name], function(err, result) {
      if (err != null) {
        return next(err);
      }
      menus[name] = result;
      return next(null, result);
    });
  };
  res.locals.$sitemap = {
    menus: {}
  };
  _ref = exports.menus;
  _fn = function(k, node) {
    return res.locals.$sitemap.menus[k] = function(next) {
      return buildMenu(k, next);
    };
  };
  for (k in _ref) {
    node = _ref[k];
    _fn(k, node);
  }
  return next();
};

exports = module.exports = {
  configure: function(config, app) {
    if (config == null) {
      config = {};
    }
    exports.menus = config.menus || {};
    exports.menus.maintenance = exports.menus.maintenance || {
      nodes: []
    };
    exports.menus.user = exports.menus.user || {
      nodes: []
    };
    if (app != null) {
      return app.use(menu_init);
    }
  },
  menus: {},
  init: menu_init,
  blocks: {
    menu: function(name) {
      return function(req, res, next) {
        var t;
        t = res.locals.$i18n.t;
        return res.locals.$sitemap.menus[name](function(err, menu) {
          if (err != null) {
            return next(err);
          }
          if (menu == null) {
            return next(t('not found menu %(name)s', {
              name: name
            }));
          }
          return res.render("sitemap/menu", menu, next);
        });
      };
    }
  }
};

//# sourceMappingURL=sitemap.map
