// Generated by CoffeeScript 1.7.1
var async, dust, dustHelpers, e, exports, url_builders, url_init;

async = require('async');

url_builders = [];

url_init = function(req, res, next) {
  res.locals.$url = {
    make: function(url, args, next) {
      var options;
      options = {
        url: url,
        args: args,
        req: req,
        res: res
      };
      return async.each(exports.builders, (function(x, cb) {
        return x(options, function(err, url) {
          if (err != null) {
            return cb(err);
          }
          options.url = url;
          return cb(null);
        });
      }), function(err) {
        return next(err, options.url);
      });
    }
  };
  return next();
};

exports = module.exports = {
  configure: function(config, app) {
    exports.builders = [];
    if (app == null) {
      return console.error("url::config(), app is null");
    } else {
      return app.use(url_init);
    }
  },
  builders: [],
  init: url_init,
  hostBuilder: function() {
    return function(options, next) {
      var req, res, url;
      req = options.req, res = options.res, url = options.url;
      if (req.app.locals.$host == null) {
        return next(null, url);
      }
      return next(null, req.app.locals.$host.url + url);
    };
  }
};

try {
  dust = require("dustjs-linkedin");
  dustHelpers = require("dustjs-helpers");
  dustHelpers.helpers['url.make'] = function(chunk, ctx, bodies, params) {
    var $url, k, locals, url, v;
    if (params == null) {
      params = {};
    }
    $url = ctx.get("$url");
    url = dustHelpers.helpers.tap(params.url, chunk, ctx);
    if (url == null) {
      return chunk;
    }
    locals = {};
    for (k in params) {
      v = params[k];
      if (k !== 'url') {
        locals[k] = dustHelpers.helpers.tap(params[k], chunk, ctx);
      }
    }
    return chunk.map(function(chunk) {
      return $url.make(url, locals, function(err, url) {
        return (chunk.write(err || url)).end();
      });
    });
  };
} catch (_error) {
  e = _error;
}

//# sourceMappingURL=url.map
