// Generated by CoffeeScript 1.7.1
var dust, dustHelpers, e, exports, fs;

fs = require('fs');

exports = module.exports = {
  isAbsolute: function(path) {
    if ('/' === path[0]) {
      return true;
    }
    if (':' === path[1] && '\\' === path[2]) {
      return true;
    }
    if ('\\\\' === path.substring(0, 2)) {
      return true;
    }
  },
  toHtml: function(item) {
    var k, s, v;
    s = "<" + item.tag;
    for (k in item) {
      v = item[k];
      if (typeof v !== 'object' && k !== 'tag' && k !== 'text') {
        s += " " + k + "='" + v + "'";
      }
    }
    s += ">";
    if (item.text != null) {
      s += item.text;
    }
    return s += "</" + item.tag + ">";
  },
  allDirectories: function(folder) {
    var dirs, file, filePath, files, stat, _i, _len;
    files = fs.readdirSync(folder);
    dirs = [];
    for (_i = 0, _len = files.length; _i < _len; _i++) {
      file = files[_i];
      if (file[0] !== '.') {
        filePath = "" + folder + "/" + file;
        stat = fs.statSync(filePath);
        if (stat.isDirectory()) {
          dirs.push(file);
        }
      }
    }
    return dirs;
  }
};

try {
  dust = require("dustjs-linkedin");
  dustHelpers = require("dustjs-helpers");
  dustHelpers.helpers['html'] = function(chunk, ctx, bodies, params) {
    var target;
    if (params == null) {
      params = {};
    }
    target = ctx.get("target");
    if (target == null) {
      return chunk;
    }
    chunk.write(exports.toHtml, target);
    return chunk;
  };
} catch (_error) {
  e = _error;
}

//# sourceMappingURL=utils.map
