// Generated by CoffeeScript 1.7.1
var async, createView, exists, exports, fs, path, requireAll, utils, view_addViewPath, view_configure, view_viewPaths, _, _folders,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

async = require('async');

requireAll = require('require-all');

path = require('path');

fs = require('fs');

_ = require('underscore');

utils = require('./utils');

exists = fs.existsSync || path.existsSync;

_folders = [];

createView = function(app) {
  var ExpressView, TemplateView;
  ExpressView = app.get("view");
  TemplateView = (function(_super) {
    __extends(TemplateView, _super);

    function TemplateView(name, options) {
      TemplateView.__super__.constructor.call(this, name, options);
      this;
    }

    TemplateView.prototype.lookup = function(filename) {
      var absoluteFileName, extname, filenames, folder, _i, _j, _len, _len1;
      extname = path.extname(filename);
      if (!utils.isAbsolute(filename)) {
        filename = filename.slice(0, filename.length - extname.length);
        filenames = filename.split(",");
        for (_i = 0, _len = _folders.length; _i < _len; _i++) {
          folder = _folders[_i];
          if (folder != null) {
            for (_j = 0, _len1 = filenames.length; _j < _len1; _j++) {
              filename = filenames[_j];
              absoluteFileName = path.join(folder, filename + extname);
              if (exists(absoluteFileName)) {
                return absoluteFileName;
              }
            }
          }
        }
      }
      if (exists(filename)) {
        return filename;
      }
    };

    return TemplateView;

  })(ExpressView);
  return TemplateView;
};

view_configure = function(config, app) {
  _folders = config.folders || [];
  if (app != null) {
    return app.set("view", createView(app));
  }
};

view_viewPaths = (function(_this) {
  return function() {
    return _folders;
  };
})(this);

view_addViewPath = (function(_this) {
  return function(view_path) {
    return _folders.unshift(view_path);
  };
})(this);


/*
    constructor
    config: {
        folders
    }
    methods: {
    }
    properties:
 */

exports = module.exports = {
  configure: view_configure,
  viewPaths: view_viewPaths,
  addViewPath: view_addViewPath
};

//# sourceMappingURL=view.map
